//Codec Windows-1251
//  - Windows-1251

//  (.   2015 2)
//  DllHandler


#include <cstdio>
#include <clocale>
#include "../DllHandler/DllHandler.h"


#define DIGCF_ALLCLASSES	0x00000004
#define DIGCF_PRESENT	    0x00000002
#define SPDRP_FRIENDLYNAME	12
#define SPDRP_DEVICEDESC	0

int main() {

    setlocale(0, "");


    DllHandler setupapi("setupapi.dll");
    if (!setupapi.hasHandle())
        return -1000;

    typedef PVOID HDEVINFO;

    struct SP_DEVINFO_DATA {
        DWORD cbSize;
        GUID  ClassGuid;
        DWORD DevInst;
        ULONG_PTR Reserved;
    };


    //SetupDiGetClassDevs  setupapi.dll.  :
    typedef HDEVINFO (CALLBACK *SetupDiGetClassDevs_ptr)(LPCGUID, PCWSTR, HWND, DWORD);
    SetupDiGetClassDevs_ptr SetupDiGetClassDevs_api = (SetupDiGetClassDevs_ptr)setupapi.receive("SetupDiGetClassDevsW");

    //SetupDiEnumDeviceInfo  setupapi.dll.  :
    typedef  BOOL (CALLBACK *SetupDiEnumDeviceInfo_ptr)(HDEVINFO, DWORD, SP_DEVINFO_DATA*);
    SetupDiEnumDeviceInfo_ptr SetupDiEnumDeviceInfo_api = (SetupDiEnumDeviceInfo_ptr)setupapi.receive("SetupDiEnumDeviceInfo");

    //SetupDiGetDeviceRegistryProperty  setupapi.dll.  :
    typedef BOOL (CALLBACK *SetupDiGetDeviceRegistryProperty_ptr)(HDEVINFO, SP_DEVINFO_DATA*, DWORD, PDWORD, PBYTE, DWORD, PDWORD );
    SetupDiGetDeviceRegistryProperty_ptr SetupDiGetDeviceRegistryProperty_api =
        (SetupDiGetDeviceRegistryProperty_ptr)setupapi.receive("SetupDiGetDeviceRegistryPropertyA");

    //SetupDiDestroyDeviceInfoList  setupapi.dll.  :
    typedef BOOL (CALLBACK *SetupDiDestroyDeviceInfoList_ptr)(HDEVINFO);
    SetupDiDestroyDeviceInfoList_ptr SetupDiDestroyDeviceInfoList_api =
        (SetupDiDestroyDeviceInfoList_ptr)setupapi.receive("SetupDiDestroyDeviceInfoList");

    if ( !(SetupDiGetClassDevs_api && SetupDiEnumDeviceInfo_api &&
           SetupDiGetDeviceRegistryProperty_api && SetupDiDestroyDeviceInfoList_api))
        return -2000;


    SP_DEVINFO_DATA DeviceInfoData;
    DeviceInfoData.cbSize = sizeof(SP_DEVINFO_DATA);//
    const DWORD BufferSize = 1024; // 
    char Buffer[BufferSize];
    HDEVINFO lst = SetupDiGetClassDevs_api(NULL, NULL, NULL, DIGCF_ALLCLASSES | DIGCF_PRESENT);
    if (INVALID_HANDLE_VALUE == lst)
        return -3000;
    int k = 0;
    while (SetupDiEnumDeviceInfo_api(lst, k, &DeviceInfoData)) {
        if (
            SetupDiGetDeviceRegistryProperty_api(lst, &DeviceInfoData, SPDRP_FRIENDLYNAME, NULL, (BYTE *)Buffer, BufferSize, NULL)
        )
            printf("%s\n", Buffer);
        else if (
            SetupDiGetDeviceRegistryProperty_api(lst, &DeviceInfoData, SPDRP_DEVICEDESC, NULL, (BYTE *)Buffer, BufferSize, NULL)
        )
            printf("%s\n", Buffer);
        k++;
    }
    SetupDiDestroyDeviceInfoList_api(lst);//  


    printf("\n\n ...\n");
    getchar();

    return 0;


}
