//Codec for this file is Windows-1251

/*

              CppSysInfo v.1.00 beta4 ANSI (Rus) mod. jul. 2015

                   -    API.

     -  ,  
  API -     ..

 ..,  2015
sadovoya@mtu-net.ru
sadovoya.narod.ru

 , " "

*/

#include "../DllHandler/DllHandler.h"
#include <psapi.h>
#include <tlhelp32.h>
#include <iostream>
#include <string>
#include <cstdio>

using std::cout;
using std::endl;
using std::string;


//-----------------------------------------------------------------------------
//                          

DWORD GetProcessesByTlHelp32(PROCESSENTRY32 *peArray, const DWORD len);

DWORD GetPrintersInfoByWinspool(PRINTER_INFO_2A *printersInfoAr, DWORD len);

bool setHighPriv();

DWORD GetProcessesNT_By_Psapi(string procArray[], const DWORD len);

//-----------------------------------------------------------------------------



int main() {

    if (setlocale(0, ""))
        cout << " : " << setlocale(LC_ALL, NULL) << endl << endl;
    else cout << "Error: Can't set Russian!\n\n";

    cout << " " << endl;

    cout << endl;

    const DWORD LEN = MAX_PATH + 1;
    char chAr[LEN];

    DllHandler dll_kernel32("kernel32");

    OSVERSIONINFOA vi;

    {
        typedef BOOL (CALLBACK *FUN)(OSVERSIONINFOA *);
        FUN fun = (FUN)dll_kernel32.receive("GetVersionExA");
        if (fun) { //  .   -NULL
            vi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOA); // 
            if (fun(&vi)) {
                const DWORD pltID = vi.dwPlatformId;
                cout << "ID : " << pltID;
                if (pltID == VER_PLATFORM_WIN32s)
                    cout << " (Win32s  Windows 3.1)";
                else if (pltID == VER_PLATFORM_WIN32_WINDOWS)
                    cout << " (Win32  Windows 95/98/Me)";
                else if (pltID == VER_PLATFORM_WIN32_NT)
                    cout << " (Win32NT  Windows NT/2000/XP...)";
                else cout <<  " (.)";
                cout << endl;
                cout << "  : "
                     << vi.dwMajorVersion
                     << "."
                     << vi.dwMinorVersion
                     << endl;
                DWORD bn = 0;
                if (vi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) //Win9x/Me
                    bn = LOWORD(vi.dwBuildNumber);
                else bn = vi.dwBuildNumber; //
                cout << " : " << bn << endl;
                cout << "SP ( WinNT,  ): " << vi.szCSDVersion << endl;
            } else cout << " GetVersionExA" << endl;
        } else cout << "  GetVersionExA" << endl;
    }

    cout << endl;

    {
        typedef DWORD (CALLBACK *FUN)(DWORD, LPSTR, DWORD);
        FUN fun = (FUN)dll_kernel32.receive("VerLanguageNameA");
        typedef LANGID (CALLBACK *FUN1)(void);
        FUN1 fun1 = (FUN1)dll_kernel32.receive("GetSystemDefaultLangID");
        if (fun && fun1) {
            if (fun(fun1(), chAr, LEN))
                cout << ": " << chAr << endl;
            else cout << " VerLanguageNameA"
                          "/ GetSystem DefaultLangID"<< endl;
        } else cout << "  VerLanguageNameA "
                        "/ GetSystem DefaultLangID" << endl;
    }

    cout << endl;

    DllHandler dll_advapi32("advapi32");

    {
        typedef BOOL (CALLBACK *FUN)(LPSTR, PDWORD);
        FUN fun = (FUN)dll_advapi32.receive("GetUserNameA");
        if (fun) {
            DWORD d = LEN;
            if (fun(chAr, &d))
                cout << " : " << chAr << endl;
            else cout << " GetUserNameA" << endl;
        } else cout << "  GetUserNameA" << endl;
    }

    cout << endl;

    {
        typedef BOOL (CALLBACK *FUN)(LPSTR, PDWORD);
        FUN fun = (FUN)dll_kernel32.receive("GetComputerNameA");
        if (fun) {
            DWORD d = LEN;
            if (fun(chAr, &d))
                cout << " : " << chAr << endl;
            else cout << " GetComputerNameA" << endl;
        } else cout << "  GetComputerNameA" << endl;
    }

    cout << endl;

    {
        typedef UINT (CALLBACK *FUN)(LPSTR, UINT);
        FUN fun = (FUN)dll_kernel32.receive("GetWindowsDirectoryA");
        if (fun) {
            if (fun(chAr, LEN))
                cout << " Windows: " << chAr << endl;
            else cout << " GetWindowsDirectoryA" << endl;
        } else cout << "  GetWindowsDirectoryA" << endl;
    }

    cout << endl;

    {
        typedef UINT (CALLBACK *FUN)(LPSTR, UINT);
        FUN fun = (FUN)dll_kernel32.receive("GetSystemDirectoryA");
        if (fun) {
            if (fun(chAr, LEN))
                cout << " : " << chAr << endl;
            else cout << " GetSystemDirectoryA" << endl;
        } else cout << "  GetSystemDirectoryA" << endl;
    }

    cout << endl;

    {
        typedef DWORD (CALLBACK *FUN)(DWORD, LPSTR);
        FUN fun = (FUN)dll_kernel32.receive("GetCurrentDirectoryA");
        if (fun) {
            if (fun(LEN, chAr))
                cout << " : " << chAr << endl;
            else cout << " GetCurrentDirectoryA" << endl;
        } else cout << "  GetCurrentDirectoryA" << endl;
    }

    cout << endl;

    {
        typedef VOID (CALLBACK *FUN)(LPMEMORYSTATUS);
        FUN fun = (FUN)dll_kernel32.receive("GlobalMemoryStatus");
        if (fun) {
            MEMORYSTATUS ms;
            //   dwLength   
            //    GlobalMemoryStatusEx
            fun(&ms);
            cout << " GlobalMemoryStatus (  ):\n";
            if (ms.dwTotalPhys) //  
                cout << " : " << ms.dwMemoryLoad << " %\n"
                     << " : \n"
                     << ms.dwTotalPhys/1024/1024 << "  (),\n"
                     << ms.dwTotalPageFile/1024/1024 << "  (.),\n"
                     << ms.dwTotalVirtual/1024/1024 << "  (.)\n"
                     << " : \n"
                     << ms.dwAvailPhys/1024/1024 << "  (),\n"
                     << ms.dwAvailPageFile/1024/1024 << "  (.),\n"
                     << ms.dwAvailVirtual/1024/1024 << "  (.)\n";
            else cout << " GlobalMemoryStatus" << endl;
        } else cout << "  GlobalMemoryStatus" << endl;
    }

    cout << endl;

    //.   "" - GlobalMemoryStatusEx().
    {
        typedef struct _MEMORYSTATUSEX_API {
            DWORD dwLength;
            DWORD dwMemoryLoad;
            DWORDLONG ullTotalPhys;
            DWORDLONG ullAvailPhys;
            DWORDLONG ullTotalPageFile;
            DWORDLONG ullAvailPageFile;
            DWORDLONG ullTotalVirtual;
            DWORDLONG ullAvailVirtual;
            DWORDLONG ullAvailExtendedVirtual;
        } MEMORYSTATUSEX_API;
        typedef BOOL (CALLBACK* FUN)(MEMORYSTATUSEX_API*);
        FUN fun = (FUN)dll_kernel32.receive("GlobalMemoryStatusEx");
        if (fun) {
            MEMORYSTATUSEX_API msx;
            msx.dwLength = sizeof (msx); //   
            if (fun(&msx))
                cout << " GlobalMemoryStatusEx:\n"
                     << " : " << msx.dwMemoryLoad << " %\n"
                     << " :\n"
                     << msx.ullTotalPhys/1024/1024 << "  (),\n"
                     << msx.ullTotalPageFile/1024/1024 << "  (.),\n"
                     << msx.ullTotalVirtual/1024/1024 << "  (.)\n"
                     << " :\n"
                     << msx.ullAvailPhys/1024/1024 << "  (),\n"
                     << msx.ullAvailPageFile/1024/1024 << "  (.),\n"
                     << msx.ullAvailVirtual/1024/1024 << "  (.),\n"
                     << " . (  0): "
                     << msx.ullAvailExtendedVirtual/1024/1024 << " \n";
            else cout << " GlobalMemoryStatusEx" << endl;
        } else cout << "  GlobalMemoryStatusEx" << endl;
    }

    cout << "\n: \n    > 2 "
         "GlobalMemoryStatus() \n   . "
         "\n GlobalMemoryStatusEx() .\n";

    cout << endl;

    DllHandler dll_psapi("psapi");

    {
        typedef BOOL (CALLBACK* FUN)(PERFORMANCE_INFORMATION*, DWORD);
        FUN fun = (FUN)dll_psapi.receive("GetPerformanceInfo");
        if (fun) {
            PERFORMANCE_INFORMATION pInf;
            pInf.cb = sizeof(PERFORMANCE_INFORMATION);//  
            if (fun(&pInf, pInf.cb))
                cout << " GetPerformanceInfo:\n"
                     << " ( / ), : "
                     << pInf.PageSize*pInf.PhysicalTotal/1024/1024
                     << " / "
                     << pInf.PageSize*pInf.PhysicalAvailable/1024/1024
                     << "\n  . / . / .: "
                     << pInf.ProcessCount << " / " << pInf.ThreadCount
                     << " / " << pInf.HandleCount
                     << endl;
            else cout << " GetPerformanceInfo" << endl;
        } else cout << "  GetPerformanceInfo" << endl;
    }

    cout << endl;

    {
        typedef VOID (CALLBACK *FUN)(LPSYSTEM_INFO);
        FUN fun = (FUN)dll_kernel32.receive("GetSystemInfo");
        if (fun) {
            SYSTEM_INFO si;
            si.wProcessorArchitecture = 12345; //  
            fun(&si);
            if (si.wProcessorArchitecture == 12345)
                cout << " GetSystemInfo\n";
            else {
                cout << " GetSystemInfo "
                     "(    Intel):\n";
                if (si.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_INTEL) {
                    WORD PrLev = si.wProcessorLevel;
                    cout << "(Intel)  : " << PrLev;
                    if      (PrLev == 3) cout << " (80386)";
                    else if (PrLev == 4) cout << " (80486)";
                    else if (PrLev == 5) cout << " (Pentium)";
                    else if (PrLev == 6) cout << " (Pentium Pro)";
                    else cout << " (.)";
                    cout << endl;
                } else cout << "  Intel-.\n";
            }
        } else cout << "  GetSystemInfo" << endl;
    }

    cout << endl;

    DllHandler dll_user32("user32");

    {
        typedef BOOL (CALLBACK *FUN)(LPCSTR, DWORD, PDISPLAY_DEVICEA, DWORD);
        FUN fun = (FUN)dll_user32.receive("EnumDisplayDevicesA");
        if (fun) {
            DISPLAY_DEVICEA dd;
            dd.cb = sizeof(DISPLAY_DEVICEA);
            if (fun(0, 0, &dd, 0))
                cout << ": " << dd.DeviceString << endl;
            else cout << " EnumDisplayDevicesA" << endl;
        } else cout << "  EnumDisplayDevicesA" << endl;
    }

    cout << endl;

    DllHandler dll_winspool("winspool.drv");

    {
        typedef BOOL (CALLBACK* FUN)(CHAR *, LPDWORD);
        FUN fun = (FUN)dll_winspool.receive("GetDefaultPrinterA");
        if (fun) {
            DWORD sz = LEN;
            if (fun(chAr, &sz))
                cout << " -: " << chAr << endl;
            else cout << " GetDefaultPrinterA\n";
        } else cout << "  GetDefaultPrinterA\n";
    }

    cout << endl;

    {
        const DWORD num_pr = 200; //-    
        PRINTER_INFO_2A pi[num_pr];
        DWORD k = GetPrintersInfoByWinspool(pi, num_pr);
        if (k) {
            cout << ":\n";
            for (DWORD i = 0; i < k; ++i)
                cout << pi[i].pPrinterName
                     << " ( . "
                     << pi[i].pDevMode->dmDriverVersion
                     << ")\n";
        } else cout << " GetPrintersInfoByWinspool "
                        "   \n";
    }

    cout << endl;

    {
        typedef UINT (CALLBACK* FUN)(LPCSTR);
        FUN fun = (FUN)dll_kernel32.receive("GetDriveTypeA");
        if (fun) {
            char dn[]= "?:";
            cout << ":\n";
            for (char i = 'A'; i <= 'Z'; ++i) {
                dn[0] = i;
                UINT typD = fun(dn);
                if (typD != DRIVE_NO_ROOT_DIR) {
                    cout << dn;
                    switch (typD) {
                    case DRIVE_FIXED :
                        cout << " ()";
                        break;
                    case DRIVE_CDROM :
                        cout << " ( CD/DVD)";
                        break;
                    case DRIVE_REMOVABLE :
                        cout << " ()";
                        break;
                    case DRIVE_REMOTE :
                        cout << " ()";
                        break;
                    case DRIVE_RAMDISK :
                        cout << " (RAM)";
                        break;
                    case DRIVE_UNKNOWN :
                        cout << " (.)";
                    //break;
                    default :
                        cout << " (?)";
                    }
                    cout << endl;
                }
            }
        } else cout << "  GetDriveTypeA" << endl;
    }

    cout << endl;

    const DWORD LEN_PR = 100;

    {
        PROCESSENTRY32 peAr[LEN_PR];
        DWORD c = 0;
        c = GetProcessesByTlHelp32(peAr, LEN_PR);
        if (c) {
            if ( c == LEN_PR ) cout << " " << LEN_PR << " .:\n";
            else cout << "  (" << c << ") :\n";
            DWORD th_count = 0;
            for (DWORD i = 0; i < c; ++i) {
                cout << "#" << i + 1 << '\t'
                     << "th32ID: " << peAr[i].th32ProcessID << '\t'
                     << peAr[i].szExeFile
                     << endl;
                th_count += peAr[i].cntThreads;
            }
            cout << " : " << th_count
                 << " ( ?)" << endl;
        } else cout << " GetProcessesByTlHelp32" << endl;
    }

    cout << endl;

    {
        DWORD numb;
        string pA[LEN_PR];
        if (vi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
            //----------
            //     SeDebugPrivilege,
            //     .    
            // .

            if (setHighPriv()) {
                cout << " \n";
            } else cout << "  \n";

            //----------

            numb = GetProcessesNT_By_Psapi(pA, LEN_PR);
            if (numb) {
                if ( numb == LEN_PR ) cout << " "
                                               << LEN_PR << " .:\n";
                else cout << "  (" << numb << ") :\n";
                for (DWORD i = 0; i < numb; ++i)
                    cout << "#" << (i+1) << '\t' << pA[i] << endl;
                cout << "\n:    .  "
                     "\n -  \n";
            } else cout << " GetProcessesNT_By_Psapi" << endl;
        } else cout << "GetProcessesNT_By_Psapi   ( WinNT)\n";
    }

    cout << endl;

    //     :
    dll_advapi32.freeDll();
    dll_kernel32.freeDll();
    dll_psapi.freeDll();
    dll_user32.freeDll();
    dll_winspool.freeDll();

    if(DllHandler::validHandlesCount())
        cout << "  dll   \n";

    cout << "\n.  ...";
    getchar();

    return 0;

}


////////////////////////////////////////////////////////////////////////////////


// (  tlhelp32.h):
DWORD GetProcessesByTlHelp32(PROCESSENTRY32 *peArray, const DWORD len) {

    DllHandler dll_kernel32("kernel32");

    typedef HANDLE (CALLBACK *FUN_CTH32S)(DWORD, DWORD);
    FUN_CTH32S cth32s
        = (FUN_CTH32S)dll_kernel32.receive("CreateToolhelp32Snapshot");
    if (!cth32s)
        return 0;

    typedef BOOL (CALLBACK *FUN_P32)(HANDLE, LPPROCESSENTRY32);
    FUN_P32 p32f = (FUN_P32)dll_kernel32.receive("Process32First");
    FUN_P32 p32n = (FUN_P32)dll_kernel32.receive("Process32Next");
    if ( (!p32f) || (!p32n) )
        return 0;

    typedef BOOL (CALLBACK *FUN_CH)(HANDLE);
    FUN_CH clhndl = (FUN_CH)dll_kernel32.receive("CloseHandle");
    if (!clhndl)
        return 0;

    HANDLE handSnap = cth32s(TH32CS_SNAPPROCESS, 0);
    if (handSnap == INVALID_HANDLE_VALUE)
        return 0; //CloseHandle()    

    DWORD i = 0;
    PROCESSENTRY32 pe;
    pe.dwSize = sizeof(pe);
    if (p32f(handSnap, &pe))
        do {
            peArray[i] = pe;
            ++i;
        } while ((p32n(handSnap, &pe)) && (i < len));

    clhndl(handSnap);

    return i;
}

DWORD GetPrintersInfoByWinspool(PRINTER_INFO_2A *printersInfoAr, DWORD len) {
    typedef BOOL (CALLBACK* LPFN)(DWORD,LPSTR,DWORD,LPBYTE,DWORD,LPDWORD,LPDWORD);
    DllHandler h("winspool.drv");
    LPFN lpfn = (LPFN)h.receive("EnumPrintersA");
    if (!lpfn) // 
        return 0;
    DWORD  cbNeeded;  // /   
    DWORD  cReturned; // 
    DWORD  flags = PRINTER_ENUM_LOCAL | PRINTER_ENUM_CONNECTIONS; //
    DWORD  sz = len*sizeof(PRINTER_INFO_2A);
    if (lpfn(flags, NULL, 2, (LPBYTE)printersInfoAr, sz, &cbNeeded, &cReturned))
        return cReturned;
    else
        return 0;
}

bool setHighPriv () {
    //     SeDebugPrivilege

    DllHandler dll_kernel32("kernel32");

    typedef HANDLE (CALLBACK *GCTH)(void);
    GCTH gcth = (GCTH)dll_kernel32.receive("GetCurrentThread");
    if (!gcth)
        return false;

    typedef BOOL (CALLBACK *FUN_CH)(HANDLE);
    FUN_CH clhndl = (FUN_CH)dll_kernel32.receive("CloseHandle");
    if (!clhndl)
        return false;

    DllHandler dll_advapi32("advapi32");

    typedef BOOL (CALLBACK *IMS)(SECURITY_IMPERSONATION_LEVEL);
    IMS ims = (IMS)dll_advapi32.receive("ImpersonateSelf");
    if (!ims)
        return false;

    if (!ims(SecurityImpersonation))
        return false;

    typedef BOOL (CALLBACK *OPTHT)(HANDLE, DWORD, BOOL, PHANDLE);
    OPTHT optht = (OPTHT)dll_advapi32.receive("OpenThreadToken");
    if (!optht)
        return false;

    typedef BOOL (CALLBACK *LPRV)(LPCWSTR, LPCSTR, PLUID);
    LPRV lprv = (LPRV)dll_advapi32.receive("LookupPrivilegeValueA");
    if (!lprv)
        return false;

    typedef BOOL (CALLBACK *ADJTPR)(HANDLE, BOOL, PTOKEN_PRIVILEGES,
                                    DWORD, PTOKEN_PRIVILEGES, PDWORD);
    ADJTPR adjtpr = (ADJTPR)dll_advapi32.receive("AdjustTokenPrivileges");
    if (!adjtpr)
        return false;

    HANDLE hToken;

    if (!optht(
                gcth(),// 
                TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY,
                FALSE,
                &hToken
            ))
        return false;

    TOKEN_PRIVILEGES tp;
    LUID luid;
    const char DP[] = "SeDebugPrivilege";
    bool res = false;
    if (lprv( NULL, DP, &luid )) {
        tp.PrivilegeCount = 1;
        tp.Privileges[0].Luid = luid;
        tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
        DWORD cb = sizeof(TOKEN_PRIVILEGES);
        res = adjtpr( hToken, false, &tp, cb, NULL, NULL );
    }

    clhndl(hToken); //  

    return res;
}


DWORD GetProcessesNT_By_Psapi(string procArray[], const DWORD len) {
    //    setHighPrivil,    
    //    .

    DllHandler dll_kernel32("kernel32");

    typedef HANDLE (CALLBACK *OPP)(DWORD, BOOL, DWORD);
    OPP opp = (OPP)dll_kernel32.receive("OpenProcess");
    if (!opp)
        return 0;

    typedef BOOL (CALLBACK *FUN_CH)(HANDLE);
    FUN_CH clhndl = (FUN_CH)dll_kernel32.receive("CloseHandle");
    if (!clhndl)
        return 0;

    DllHandler dll_psapi("psapi");

    typedef BOOL (CALLBACK* ENPR)(DWORD *, DWORD, DWORD *);
    ENPR enpr = (ENPR)dll_psapi.receive("EnumProcesses");
    if(!enpr)
        return 0;

    DWORD cbNeeded, lp[1000];
    if (!enpr(lp, sizeof(lp), &cbNeeded))
        return 0;

    typedef DWORD (CALLBACK* GMFNX)(HANDLE, HMODULE, LPSTR, DWORD);
    GMFNX gmfnx = (GMFNX)dll_psapi.receive("GetModuleFileNameExA");
    if (!gmfnx)
        return 0;

    DWORD num = cbNeeded / sizeof(DWORD);

    HANDLE procHndl;
    char modName[ MAX_PATH + 1 ];
    DWORD i = 0;
    for (i = 0; ((i < num) && (i < len)); ++i) {
        procHndl = opp(
                       //PROCESS_ALL_ACCESS,
                       PROCESS_QUERY_INFORMATION|PROCESS_VM_READ,
                       false,
                       lp[i]
                   );
        if (gmfnx(procHndl, NULL, modName, sizeof(modName)))
            procArray[i] = modName;
        else if (!procHndl)
            procArray[i] = "? (/ Handle)";
        else procArray[i] = "???";
        if (procHndl)
            clhndl(procHndl);
    }

    return i;
}

