//Codec for this file is Windows-1251
//   - Windows-1251

/*==============================================================================
                                 DllHandler
                     
                    1.00 beta6, , . 2015
     ------------------------------------------------------------

     :  
     sadovoya@mtu-net.ru
     http://sadovoya.narod.ru

       (OpenSource), " ".

==============================================================================*/


/* -------------------            ------------------------------

   ,  / 
      ( )    .
    (  )
     ,    .
   ,         .
    -  .

       private,  
   (       
,    -  -     ).

       .   
     .     ANSI    unicode
   .

,      .,     ,
 - hasHandle()  true/false   /.

   - ( FARPROC)    
receive(),      -.    
NULL.   -       
   - (     ; ,
 -   Windows API,      MSDN).  
 - . .   (   -)   
NULL,  ,  -      
   . , ,   ()  NULL, 
   -      . 
     .

      , ,
   ,    .       
 freeDll(),      (     
hasHandle()).       ,  ()
  freeDll.   ,  Windows  
       ( ,  
   ).

    -  .    
    ()   .  ,
        , 
 .

     (   
 freeDll()).       
. .. - ( new) -    
 delete,  -        
  (  ).     
 .     ,
    ,      
 (       - , 
      ).    
    .      
  validHandlesCount(),       
   .      ""  
  .      
  (  new  delete),    
  ( ) ""       
       (   
,     ).    
   freeDll()     hasHandle()
(    false).   , Windows 
     ,    
 .

     -     
 -  .     .  
       -  ()
   NULL,   .     
""  ,     (  API:
LoadLibrary, GetProcAddress, FreeLibrary  GetLastError),   
     .
------------------------------------------------------------------------------*/


#ifndef DLLHANDLER_H
#define DLLHANDLER_H

#include <windows.h>

class DllHandler {

    HMODULE hDLL; // Handle  DLL (NULL - )

    static int valid_handles_count; //  handle 

    //  privat    =
    DllHandler(const DllHandler& );
    DllHandler& operator=(const DllHandler& );

public:
    //   dll (ANSI-):
    DllHandler(const char* dll_name);

    //   dll ( unicode):
    DllHandler(const wchar_t* dll_name);

    ~DllHandler() {
        freeDll();
    }

    bool hasHandle(); // ,      dll

    FARPROC receive(const char* fun_name); //  -  dll   

    void freeDll(); //  dll

    static int validHandlesCount() {
        return valid_handles_count;
    }
    //      . handle  

};

#endif // DLLHANDLER_H
