//Codec for this file is Windows-1251
//   - Windows-1251

//  DllHandler

#include <cstdio>
#include <clocale>
#include "../DllHandler/DllHandler.h"


typedef void (__stdcall* PFun1)(LPMEMORYSTATUS);
// GlobalMemoryStatus()
//http://msdn.microsoft.com/en-us/library/windows/desktop/aa366586(v=vs.85).aspx

typedef BOOL (__stdcall* PFun2)(WCHAR *, DWORD *);
// GetDefaultPrinterW()


int main() {

    //        
    if (setlocale(LC_ALL, "Russian_Russia.1251"))
        printf(" : %s\n\n", setlocale(LC_ALL, NULL));
    else
        printf("Error: Can't set locale!\n\n");



//(1)    ------------------------------------------

    //         .
    DllHandler libKernel32("kernel32");
    PFun1 p_gms = (PFun1)libKernel32.receive("GlobalMemoryStatus");

    //   - ,  - 
    // (   NULL).    
    //  -.
    if (p_gms) {
        // -
        MEMORYSTATUS ms;
        p_gms(&ms);
        printf(" : %lu %%\n", ms.dwMemoryLoad);
    } else printf("  -   \n");

    printf("\n");


//(2)   -----------------------------------------------

    DllHandler *libKernel32_ptr = new DllHandler("kernel32");
    PFun1 p_gms2 = (PFun1)libKernel32_ptr->receive("GlobalMemoryStatus");
    if (p_gms2) {
        // -
        MEMORYSTATUS ms;
        p_gms2(&ms);
        printf(" : %lu %%\n", ms.dwMemoryLoad);
    } else printf("  -   \n");
    delete libKernel32_ptr; //

    printf("\n");


//(3)    (.drv)  unicode  --------------------

    DllHandler libWinspool(L"winspool.drv"); // dll  unicode
    if (libWinspool.hasHandle()) { //   , 
        //   ,   
        PFun2 p_dp = (PFun2)libWinspool.receive("GetDefaultPrinterW");
        //unicode  API - GetDefaultPrinter()
        if (p_dp) { //  
            WCHAR defPr[500];
            DWORD len = sizeof(defPr)/sizeof(defPr[0]);
            if (p_dp(defPr, &len)) {
                printf(" -: ");
                wprintf(L"%s\n", defPr);
            } else printf("    -\n");
        } else printf("  -\n");
    } else printf("  \n");

    printf("\n");

//(4)    validHandlesCount()-------------------------------

    //      2 .
    printf("   .: %d \n", DllHandler::validHandlesCount());
    printf("(  ,   2)\n");

    const int num = 5;
    DllHandler *p[num];

    for (int i = 0; i < num; ++i)
        p[i] = new DllHandler("kernel32");
    printf("  %d DllHandler   .: %d\n", num,
           DllHandler::validHandlesCount());

    for (int i = 0; i < num; ++i)
        delete p[i];
    printf("  %d DllHandler   .: %d\n", num,
           DllHandler::validHandlesCount());
    printf("(  ,   2)\n");

    //       .
    //,       :
    libWinspool.freeDll();
    libKernel32.freeDll();
    printf("   .: %d .\n",
           DllHandler::validHandlesCount());

    printf("\n ..");
    getchar();

    return 0;
}
